function y = scale_matrix(x, scaling_vec, band_size)
% multiply each band of the matrix x with scaling_vec
y = x;
levels = size(band_size, 1)-1;
x_pos = 1 + band_size(levels+1, 2);
y_pos = 1 + band_size(levels+1, 1);

y(1:band_size(levels+1, 1), 1:band_size(levels+1, 2)) = y(1:band_size(levels+1, 1), 1:band_size(levels+1, 2)).*scaling_vec(1);
for l=1:levels
    y(1:band_size(levels+2-l, 1), x_pos:x_pos+band_size(levels+2-l, 2)-1) = y(1:band_size(levels+2-l, 1), x_pos:x_pos+band_size(levels+2-l, 2)-1).*scaling_vec(3*l-1);
    y(y_pos:y_pos+band_size(levels+2-l, 1)-1, 1:band_size(levels+2-l, 2)) = y(y_pos:y_pos+band_size(levels+2-l, 1)-1, 1:band_size(levels+2-l, 2)).*scaling_vec(3*l);
    y(y_pos:y_pos+band_size(levels+2-l, 1)-1, x_pos:x_pos+band_size(levels+2-l, 2)-1) = y(y_pos:y_pos+band_size(levels+2-l, 1)-1, x_pos:x_pos+band_size(levels+2-l, 2)-1).*scaling_vec(3*l+1);
    x_pos = x_pos + band_size(levels+2-l, 2);
    y_pos = y_pos + band_size(levels+2-l, 1);
end