% This code implements fast stray light reduction
% Code is written by Jianing Wei
% Unauthorized use or coping is prohibited
clear all;
beta = 0.3937; % this is a stray light parameter

% this is where you put your image to be restored 
im = imread('../alanoriginal1.tiff');

% this is where you put your coded matrix from offline part 
coded_matrix = '../../offline/coded_matrix_2310x3088_delta_0.3.dat';

% this is where you put your scaling factors file
scaling_file = '../../offline/prediction/scaling_factors_2310x3088_10levels.txt';
scaling_factors = load(scaling_file);

stray_reduced_im = uint16(zeros(size(im)));
for i=1:size(im, 3)
    img = im(:,:,i);
    img = double(img);
    stray_img = mx_online_main_space_varying(img, coded_matrix, scaling_factors);
    stray_reduced_im(:,:,i) = uint16((1+beta)*img - beta*stray_img);
end

im = uint8((double(im)/65535).^(1/2.2)*255);
stray_reduced_im = uint8((double(stray_reduced_im)/65535).^(1/2.2)*255);
imwrite(stray_reduced_im, 'alan1restored.jpg', 'quality', 99);
