#ifndef CIMAGE_H
#define CIMAGE_H

#ifdef __cplusplus
   extern   "C"   {
#endif

#include <stdio.h>
#include <stdlib.h>

#define imaccess(imp, x, y) ((imp)->ptr[(y) * (imp)->width + (x)])

typedef struct {
    float* ptr;
	int height;
	int width;
} cimage;

typedef struct {
    unsigned char* ptr;
    int height;
    int width;
} cimage_uchar;

typedef struct {
	int* ptr;
	int height; 
	int width;
} cimage_int;

typedef struct {
	long* ptr;
	int height; 
	int width;
} cimage_long;


typedef struct {
    cimage_uchar im_ch1;
    cimage_uchar im_ch2;
    cimage_uchar im_ch3;
} cimage_fullcolor;

void initImage(cimage* imp, int height, int width);
void destroyImage(cimage* imp);
void initUcharImage(cimage_uchar* imp, int height, int width);
void destroyUcharImage(cimage_uchar* imp);
void initIntImage(cimage_int* imp, int height, int width);
void destroyIntImage(cimage_int* imp);
void initLongImage(cimage_long* imp, int height, int width);
void destroyLongImage(cimage_long* imp);
void createFullColorImg(cimage_fullcolor* imp, int height, int width);
void destroyFullColorImg(cimage_fullcolor* imp);
void rgb2Gray(cimage_fullcolor* imp, cimage_uchar* imgray);
void writeImTest(cimage *imp, char* filename);

#ifdef __cplusplus
   }
#endif

#endif
