#ifndef LIST_H
#define LIST_H

#include <stdlib.h>
#include <stdio.h>
#include "psf.h"

/* this list struct is a standard one cited from a textbook*/
struct node{
  unsigned short int pixel_row;    
  unsigned short int pixel_col; /* pixel location */
    /* unsigned char length; */
    /* unsigned short k; */
  float pixel_val;
  struct node *link;
};

typedef struct node NODE;

struct list{
    NODE* head;
    NODE* tail;
    unsigned int num_pix;
};

typedef struct list LIST;

void AddItem (LIST* linklistPTR, unsigned short int pixel_row, 
	      unsigned short int pixel_col, float value);

void ClearQueue (LIST* linklistPTR);

void ReadListmatrix(FILE *fp, LIST ** listmatrix, int height, int width);

void RecordListmatrix(FILE *fp, LIST ** listmatrix, int height, int width);

void WriteListmatrixHeader(FILE *fp, struct parameter para, float delta, int num_levels,  
                           int block_num_levels, int height, int width, int block_size);

int ReadNCheckListmatrixHeader(FILE *fp, struct parameter para, float delta, int num_levels, 
                                int block_num_levels, int height, int width, int block_size);

int ReadListmatrixHeader(FILE *fp, struct parameter *para, float *r_delta, int *r_num_levels, 
                         int *r_block_num_levels, int *r_height, int *r_width, int *r_block_size);


void FurtherQuantizeListmatrix(LIST **fine_listmatrix, 
                               LIST **coarse_listmatrix, 
		               int height, int width, float delta);

#endif
