#ifndef SPARSEWT_H
#define SPARSEWT_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>
#include "linklist.h"
#include "allocate.h"

void showvector(float *vec, int length);
void showmatrix(float **matrix, int height, int width);
void downsample(float *convdata, int width, int rownum, LINKLIST * sparse_col_matrix, int start);
void show_sparse_matrix(LINKLIST * matrix, int dimension);
void initial_sparse_matrix(LINKLIST *sparse_matrix, int dim);
void clear_sparse_matrix(LINKLIST *sparse_matrix, int dim);
void clear_vector(float *datavector, int length);
void clear_matrix(float **matrix, int height, int width);
void copy_upsamp_col(float *datavector, float **matrix, int col,
                     int row_start, int row_end, int start);
void copy_upsamp_row(float *datavector, float **matrix, int row,
                     int col_start, int col_end, int start);
void copy_sparse_matrix(LINKLIST *source_matrix, LINKLIST *dest_matrix, int length);
void sym_extend(LINKLIST *plist, int filterlen, int width);
void myconv(float *convdata, LINKLIST *plist, float *filter, int filterlen, int width);
void regconv(float *convdata, float *data, float *filter, int filterlen, int width);
void symconv(float *filter, LINKLIST * sparse_row_matrix, int filterlen,
                 int row, int width, LINKLIST * sparse_col_matrix, int ext, int start);
void wave_recon(float **wave_coef, float *lprfilter, float *hprfilter,
                int filterlen_l, int filterlen_h, int height, int width, int levels);
void sparse_decomp(float *lpfilter, float *hpfilter, LINKLIST *sparse_row_matrix, LINKLIST *wave_coef,
                   int height, int width, int levels, int filterlen_l, int filterlen_h);
void sparse_haar_decomp(float *lpfilter, float *hpfilter, LINKLIST *sparse_row_matrix, 
		   LINKLIST *wave_coef, int height, int width, int levels, 
		   int filterlen_l, int filterlen_h);
void haar_wave_recon(float **wave_coef, float *lprfilter, float *hprfilter, 
		int filterlen_l, int filterlen_h, int height, int width, int levels);


#endif




